/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2021/06/06
 * Description        : Main program body.
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * SPDX-License-Identifier: Apache-2.0
 *******************************************************************************/

/*
 *@Note
 LIṆ
 HOST-UART1λ·
     -UART2 LIN 

 SLAVE-UART2 LIN

 ʹӻֱأӦͨλݣѡǷжݸʽȷ񣬷͸ӻ

 עĬ LINݳΪ 8byteС 8Byteδ

*/

#include "debug.h"

/* Global typedef */

/* Global define */

/* Global Variable */

#define HOST   0
#define SLAVE   1

#define LIN_MODE  HOST
//#define LIN_MODE  SLAVE


/**
 * \b ʹòѯóIDֵþǷǳĿ졣
 **/
u8 idParityQueryWay( u8 ID )
{
    u8 idHadParity[64] =
    {
        0x80,0xC1,0x42,0x03,0xC4,0x85,0x06,0x47,
        0x08,0x49,0xCA,0x8B,0x4C,0x0D,0x8E,0xCF,
        0x50,0x11,0x92,0xD3,0x14,0x55,0xD6,0x97,
        0xD8,0x99,0x1A,0x5B,0x9C,0xDD,0x5E,0x1F,
        0x20,0x61,0xE2,0xA3,0x64,0x25,0xA6,0xE7,
        0xA8,0xE9,0x6A,0x2B,0xEC,0xAD,0x2E,0x6F,
        0xF0,0xB1,0x32,0x73,0xB4,0xF5,0x76,0x37,
        0x78,0x39,0xBA,0xFB,0x3C,0x7D,0xFE,0xBF,
    };
    return idHadParity[ID];
}



/**
 * \b IDУ飬ڽյIDǷϹʹ
            ֵյIDֵIDIDΪ0xFFʾID
 **/
 u8 idParityCheck( u8 IDResult )
{
    return ( idParityQueryWay( IDResult& 0x3F ) == IDResult ) ? (IDResult&0x3F):0xFF;
}

/**
 * @brief һֽڴУ麯 \para enhanceCheckIDǿУ飬ID0
 */
/*********************************************************************
 * @fn      getCheckCarry
 *
 * @brief   һֽڴУ麯
 *          DataBuf-У
 *          Length-Уݳ
 *          enhanceCheckID-Уģʽ
 *                    0-׼ģʽ
 *                                                      -ʵIDǿģʽ
 *
 * @return  һֽУ
 */
u8 getCheckCarry( u8* DataBuf,u16 Length,u8 enhanceCheckID )
{
    u16 Sum = 0;
    for( u8 i=0;i<Length;i++ ) {
        Sum += DataBuf[i];
        Sum = Sum>0xFF ? ((Sum+1)&0xFF) : Sum;
    }
    { // ǿУ飬ҪID׼ģʽ,0,Ӱ.
        Sum += enhanceCheckID;
        Sum = Sum>0xFF ? ((Sum+1)&0xFF) : Sum;
    }
    return (u8)(~Sum); // ÿλȡ
}

/* LIN */
typedef struct
{
    u8 dataLen;  // data num
    u8 sync; //ͬ֡
    u8 ID;
    u8 dataBuf[8]; // ʵʷ
    u8 dataCheckValue; //Уλ
}LinSend;

 LinSend LIN_Most_Tx;
 LinSend LIN_Most_Rx;

volatile u8 Rx_Break_Flag = 0;
volatile u8 ValidData = 0;
volatile u8 RxValidData = 0;
volatile u32 tim2_cnt = 0;  //1ms
volatile u8 Rec_cnt1 = 0; //UART1ռ
volatile u8 Rec_cnt = 0; //UART2ռ
volatile u8 ClearTIM2flag = 0; //UART2ռ


/* UART1 */
/*Ч   0x5A + 0x0A + ID(1B) + data(8B) + У飨1B + 0xA5*/
typedef struct
{
    u8 FrameHead;  // ֡ͷ  0x5A
    u8 Len; //data len (10Byte) 1
    u8 dataBuf[10]; //1byte ID + 8byte data + 1У
    u8 FrameEnd;   //// ֡ͷ  0xA5
}UART1_Rx;

UART1_Rx UART1_RXdeal;

void USART2_LIN_Init(uint32_t baudrate)
{
    GPIO_InitTypeDef GPIO_InitStructure;
    USART_InitTypeDef USART_InitStructure;
    NVIC_InitTypeDef NVIC_InitStructure;

    RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOA, ENABLE );
    RCC_APB1PeriphClockCmd( RCC_APB1Periph_USART2, ENABLE );

    //USART2_TX   PA.2
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    //USART2_RX   PA.3
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;//
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    /* USART */
    USART_InitStructure.USART_BaudRate = baudrate;
    /* USARTֳ */
    USART_InitStructure.USART_WordLength = USART_WordLength_8b; //8λ
    /* USARTֹͣλ */
    USART_InitStructure.USART_StopBits = USART_StopBits_1;      //1ֹͣλ
    /* żУ */
    USART_InitStructure.USART_Parity = USART_Parity_No; //żУ
    /* RTSCTSӲ */
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None; //Ӳ
    /* USARTģʽ */
    USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx; //շģʽ

    USART_Init(USART2, &USART_InitStructure);

    NVIC_InitStructure.NVIC_IRQChannel = USART2_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=0;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority =0;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);

    USART_ITConfig( USART2, USART_IT_RXNE, ENABLE );        //RXNEжʹ
    USART_ITConfig( USART2, USART_IT_LBD, ENABLE );     //Ͽжʹ

    /* Լ -͹̶ 13bitĵ͵ƽ + 1bitߵƽ  */
//    USART_LINBreakDetectLengthConfig( USART2, USART_LINBreakDetectLength_10b );     //LINģʽϿ֡ȣ 10bitLBDλ
  USART_LINBreakDetectLengthConfig( USART2, USART_LINBreakDetectLength_11b );  //LINģʽϿ֡ȣ 11bitLBDλ

    USART_LINCmd( USART2, ENABLE ); //ʹLINģʽ

    USART_Cmd(USART2, ENABLE);                    //ʹܴ2

}

void USART2_SendBreak(void)
{
    while(USART_GetFlagStatus(USART2, USART_FLAG_TC) == RESET);
    USART_SendBreak(USART2);
}

void USART2_SendData(u8 num, u8*buf)
{
    u8 i;

    for(i=0; i<num; i++){
        while(USART_GetFlagStatus(USART2, USART_FLAG_TC) == RESET);
        USART_SendData(USART2, *buf++);
    }
}

/*********************************************************************
 * @fn      LIN_Tx_NOVerify
 *
 * @brief   ûУ
 *
 * @return  none
 */
void LIN_Tx_NOVerify(void)
{
    u8 i;

    printf("UART1 Rx \r\n");
    for(i=0; i<10; i++){
        printf(" %02x\r\n", UART1_RXdeal.dataBuf[i]);
    }printf("\r\n");

    LIN_Most_Tx.dataLen = 8;
    LIN_Most_Tx.sync = 0x55;
    LIN_Most_Tx.ID = UART1_RXdeal.dataBuf[0];

    for(i=0; i<8; i++){
        LIN_Most_Tx.dataBuf[i] = UART1_RXdeal.dataBuf[1+i];
    }

    LIN_Most_Tx.dataCheckValue = UART1_RXdeal.dataBuf[9];

    printf("LIN Host NoVerify Send1\r\n");
    USART2_SendBreak();
    USART2_SendData(LIN_Most_Tx.dataLen + 3, &LIN_Most_Tx.sync);
    printf("Send End\r\n");
}

/*********************************************************************
 * @fn      LIN_Tx_Verify
 *
 * @brief   У
 *
 * @return  none
 */
void LIN_Tx_Verify(void)
{
    u8 i;
    u8 Vf_byte;

    printf("UART1 Rx \r\n");
    for(i=0; i<10; i++){
        printf(" %02x\r\n", UART1_RXdeal.dataBuf[i]);
    }printf("\r\n");

    LIN_Most_Tx.dataLen = 8;
    LIN_Most_Tx.sync = 0x55;
    LIN_Most_Tx.ID = UART1_RXdeal.dataBuf[0];

    for(i=0; i<8; i++){
        LIN_Most_Tx.dataBuf[i] = UART1_RXdeal.dataBuf[1+i];
    }

    LIN_Most_Tx.dataCheckValue = UART1_RXdeal.dataBuf[9];


    Vf_byte = getCheckCarry( &LIN_Most_Tx.ID, 9,  LIN_Most_Tx.ID);//ǿģʽ,ID
//    Vf_byte = getCheckCarry( LIN_Most_Tx.dataBuf, 8,  LIN_Most_Tx.ID);//׼ģʽ,ID

    if((idParityCheck(LIN_Most_Tx.ID) != 0xFF) && (Vf_byte == LIN_Most_Tx.dataCheckValue)){  //IDУͨ,1ֽУͨ
        printf("LIN Host Verify Send1\r\n");
        USART2_SendBreak();
        USART2_SendData(LIN_Most_Tx.dataLen + 3, &LIN_Most_Tx.sync);
        printf("Send End\r\n");
    }
    else if((idParityCheck(LIN_Most_Tx.ID) == 0xFF) && (Vf_byte != LIN_Most_Tx.dataCheckValue)){ //IDУ1ֽУʧ
        printf("LIN ID and Checksum ERR\r\n");
    }
    else if((idParityCheck(LIN_Most_Tx.ID) == 0xFF)){ //IDУʧ
        printf("LIN ID ERR\r\n");
    }
    else{ //1ֽУʧ
        printf("LIN Checksum ERR\r\n");
    }
}

/*********************************************************************
 * @fn      TIM2_Init
 *
 * @brief   ճʱ 15ms
 *
 * @return  none
 */
void TIM2_Init(void)
{
    TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStructure = {0};
    NVIC_InitTypeDef NVIC_InitStructure={0};

    RCC_APB1PeriphClockCmd( RCC_APB1Periph_TIM2, ENABLE );  //TIM2

    TIM_TimeBaseInitStructure.TIM_Period = 150-1; //Զװֵ
    TIM_TimeBaseInitStructure.TIM_Prescaler = 3600-1;  //ԤƵϵ
    TIM_TimeBaseInitStructure.TIM_ClockDivision = TIM_CKD_DIV1; //1Ƶ
    TIM_TimeBaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up;
    /* ظֵRCRĴ */
    TIM_TimeBaseInitStructure.TIM_RepetitionCounter =  0x00;    //TIM1 
    TIM_TimeBaseInit( TIM2, &TIM_TimeBaseInitStructure);

    NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);

    TIM_ITConfig( TIM2, TIM_IT_Update, ENABLE );
    TIM_Cmd( TIM2, ENABLE );
}


/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
    u8 i;

    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    Delay_Init();
    USART_Printf_Init(115200);

    USART2_LIN_Init(19200);
    TIM2_Init();

#if (LIN_MODE == HOST)
    printf("LIN HOST\r\n");
    Delay_Ms(1000);
    LIN_Most_Tx.dataLen = 8;
    LIN_Most_Tx.sync = 0x55;
    LIN_Most_Tx.ID = 0x80;

    for(i=0; i<8; i++){
        LIN_Most_Tx.dataBuf[i] = i;
    }

    LIN_Most_Tx.dataCheckValue = 0xAA;

    printf("LIN Host Send\r\n");
    USART2_SendBreak();
    USART2_SendData(LIN_Most_Tx.dataLen + 3, &LIN_Most_Tx.sync);
    printf("Send End\r\n");

#else

    printf("LIN SLAVE\r\n");
    Delay_Ms(10);
#endif

    while(1)
    {
#if (LIN_MODE == HOST)
        if(RxValidData){
            RxValidData = 0;

            LIN_Tx_NOVerify();
//            LIN_Tx_Verify();

        }
#else
        if(ValidData){
            ValidData = 0;
            printf("Rx vaild data:\r\n");
            printf("ID %02x\r\n", LIN_Most_Rx.ID);
            printf("dataBuf:\r\n");
            for(i=0; i<8; i++){
               printf(" %02x\r\n", LIN_Most_Rx.dataBuf[i]);
            }printf("\r\n");
            printf("dataCheckValue %02x\r\n", LIN_Most_Rx.dataCheckValue);
        }

#endif
    }
}

#if (LIN_MODE == SLAVE)
void USART2_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));

/*********************************************************************
 * @fn      USART2_IRQHandler
 *
 * @brief   LIN
 *
 * @param   baudrate - USART communication baud rate.
 *
 * @return  None
 */
void USART2_IRQHandler(void)
{
    /* Ͽжϱ־ */
    if( USART_GetITStatus( USART2, USART_IT_LBD ) != RESET )
    {
        printf( "LBD\r\n");
        Rx_Break_Flag = 1;
        tim2_cnt = 0;
        TIM2->CNT = 0;
        ClearTIM2flag =1;

        USART_ClearITPendingBit( USART2, USART_IT_LBD );    //LBDжϱ־λ
    }

    /*  */
    if( USART_GetITStatus( USART2, USART_IT_RXNE ) != RESET ){  //ݼĴǿ

        if(Rx_Break_Flag){
            Rec_cnt++;

            if(Rec_cnt == 1){
                LIN_Most_Rx.sync = USART_ReceiveData(USART2);  //ж
            }
            if(Rec_cnt == 2){
                LIN_Most_Rx.ID = USART_ReceiveData(USART2);  //ж
            }
            else if(Rec_cnt <= 10){
                LIN_Most_Rx.dataBuf[Rec_cnt-3] = USART_ReceiveData(USART2);  //ж
            }
            else if(Rec_cnt == 11){
                LIN_Most_Rx.dataCheckValue = USART_ReceiveData(USART2);  //ж
                Rx_Break_Flag = 0;
                ValidData = 1;
                Rec_cnt = 0;
                ClearTIM2flag =0;
            }
        }
        else{ /* Ч */
            USART_ReceiveData(USART2);  //ж
            Rec_cnt = 0;
        }


    }

}
#endif


#if (LIN_MODE == HOST)
void USART1_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));

/*********************************************************************
 * @fn      USART1_IRQHandler
 *
 * @brief   λݰƷ
 *      Ч   0x5A + 0x0A + ID(1B) + data(8B) + У飨1B + 0xA5
 *
 * @param   baudrate - USART communication baud rate.
 *
 * @return  None
 */
void USART1_IRQHandler(void)
{
    u8 rxdat;

    /*  */
    if( USART_GetITStatus( USART1, USART_IT_RXNE ) != RESET ){  //ݼĴǿ
        rxdat = USART_ReceiveData(USART1);  //ж
        printf("1- %02x\r\n", rxdat);
        if((Rec_cnt1 == 0) && (rxdat == 0x5A)){
            Rec_cnt1++;
            TIM2->CNT = 0;
            ClearTIM2flag =1;

        }
        else if((Rec_cnt1 == 1) && (rxdat == 0x0A)){
            Rec_cnt1++;
        }
        else if((Rec_cnt1 <= 11)){
            Rec_cnt1++;
            UART1_RXdeal.dataBuf[Rec_cnt1-3] = rxdat;
        }
        else if((Rec_cnt1 == 12) && (rxdat == 0xA5)){
            Rec_cnt1 = 0;
            RxValidData = 1;
            ClearTIM2flag =0;
        }
        else{ /* Ч */
            Rec_cnt1 = 0;
        }
    }

}


#endif

void TIM2_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));

/*********************************************************************
 * @fn      TIM2_IRQHandler
 *
 * @brief   This function TIM2 Fault exception. 10ms
 *
 * @return  none
 */
void TIM2_IRQHandler(void)
{
    if( TIM_GetITStatus( TIM2, TIM_IT_Update ) != RESET ){
        tim2_cnt++;
//printf("111\r\n");
        if(ClearTIM2flag){
//            if(tim2_cnt >= 10)
//            {
                ClearTIM2flag = 0;
//                tim2_cnt = 0;  //10ms
#if (LIN_MODE == HOST)
                Rec_cnt1 = 0;
#else
                Rec_cnt = 0;
                Rx_Break_Flag = 0;
                Rec_cnt = 0;
#endif
//            }
                printf("clear 0\r\n");
        }

    }

    TIM_ClearITPendingBit( TIM2, TIM_IT_Update );   //жϱ־λ

}
